package de.ivu.elect.presentation.internet.action;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.internet.boundary.CoreInternetSeiteBoundaryCreate;
import de.ivu.elect.business.internet.entity.InternetSeite;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.internet.InternetSeiteEditView;

@Named(InternetSeiteKopieAction.COMPONENT_NAME)
public class InternetSeiteKopieAction extends AbstractInternetSeiteAction {

  public static final String COMPONENT_NAME = "internetSeiteKopieAction";

  private static final long serialVersionUID = 1L;

  @Inject
  private transient CoreInternetSeiteBoundaryCreate internetSeiteCreate;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.INTERNET_SEITE_CREATE;
  }

  @Override
  protected String doIt(InternetSeite entity) {

    InternetSeite copy = internetSeiteCreate.copy(entity);
    messages.addInfoMessage("internet.seite.kopiert");
    conversationSelect.setEntity(copy);

    return InternetSeiteEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.copy";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconCopy();
  }
}
